---
title: CanvasRenderingContext2D.fill()
slug: Web/API/CanvasRenderingContext2D/fill
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.fill()</code></strong> method of the Canvas 2D API fills the current or given path with the current {{domxref("CanvasRenderingContext2D.fillStyle", "fillStyle")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.fill([<em>fillRule</em>]);
void <em>ctx</em>.fill(<em>path</em> [, <em>fillRule</em>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>fillRule</code></dt>
 <dd>The algorithm by which to determine if a point is inside or outside the filling region.<br>
 Possible values:
 <ul>
  <li><strong><code>"nonzero"</code></strong>: The <a href="http://en.wikipedia.org/wiki/Nonzero-rule">non-zero winding rule</a>. Default rule.</li>
  <li><code><strong>"evenodd"</strong></code>: The <a href="http://en.wikipedia.org/wiki/Even%E2%80%93odd_rule">even-odd winding rule</a>.</li>
 </ul>
 </dd>
 <dt><code>path</code></dt>
 <dd>A {{domxref("Path2D")}} path to fill.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Filling_a_rectangle">Filling a rectangle</h3>

<p>This example fills a rectangle with the <code>fill()</code> method.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[4]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
ctx.rect(10, 10, 150, 100);
ctx.fill();
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Filling_a_rectangle', 700, 180) }}</p>

<h3 id="Specifying_a_path_and_a_fillRule">Specifying a path and a fillRule</h3>

<p>This example saves some intersecting lines to a Path2D object. The <code>fill()</code> method is then used to render the object to the canvas. A hole is left unfilled in the object's center by using the <code>"evenodd"</code> rule; by default (with the <code>"nonzero"</code> rule), the hole would also be filled.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js; highlight:[16]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Create path
let region = new Path2D();
region.moveTo(30, 90);
region.lineTo(110, 20);
region.lineTo(240, 130);
region.lineTo(60, 130);
region.lineTo(190, 20);
region.lineTo(270, 90);
region.closePath();

// Fill path
ctx.fillStyle = 'green';
ctx.fill(region, 'evenodd');
</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Specifying_a_path_and_a_fillRule', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-fill", "CanvasRenderingContext2D.fill")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.fill")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.fillStyle")}}</li>
</ul>
